#!/usr/bin/perl -I/usr/sausalito/perl -I/usr/sausalito/handlers/base/appleshare

use Sauce::Config;
use Sauce::Util;
use Sauce::Service;
use CCE;
use appleshare;
use I18n;

my $cce = new CCE;
$cce->connectuds();

my $i18n=new I18n;

my @oids = $cce->find('System');
if (not @oids) {
        $cce->bye('FAIL');
        exit 1;
}

my ($ok, $obj) = $cce->get($oids[0], 'AppleShare');
unless ($ok and $obj) {
        $cce->bye('FAIL');
        exit 1;
}

# sync up system state with cce:
my $old = Sauce::Service::service_get_init('atalk') ? 'on' : 'off';
my $new = $obj->{enabled} ? 'on' : 'off';
Sauce::Service::service_set_init('atalk', $new) unless ($new eq $old);

# max users
my %settings;
$settings{'AFPD_MAX_CLIENTS'} = $obj->{maxConnections};

# sync up guest share
($ok, $obj) = $cce->get($oids[0], 'FileShare');

$settings{'AFPD_UAMLIST'} = '"-U uams_clrtxt.so,uams_dhx.so';
$settings{'AFPD_UAMLIST'} .= ',uams_guest.so' if $obj->{guestEnabled};
$settings{'AFPD_UAMLIST'} .= "\"";
$settings{'AFPD_GUEST'} = $obj->{guestUser};
Sauce::Util::editfile(appleshare::atalk_getnetatalk,
		      *Sauce::Util::keyvalue_edit_fcn,
		      '#', '=', undef, %settings);
Sauce::Util::editfile("/etc/atalk/AppleVolumes.default",
	\&editVolumes,
	$i18n->getProperty("atalkOptions","base-appleshare")
);
$cce->bye('SUCCESS');


sub editVolumes {
	my($if,$of,$options)=@_;
	my $printed=0;
	while(<$if>){
		if(/^#/){
			print $of $_;
		}else{
			unless($printed == 1){
				$printed=1;
				print $of ":DEFAULT: options:$options\n" unless ($options eq "none" 
										|| $options eq "ERROR");
			}
			print $of $_ unless /^:DEFAULT: options:$options$/;
		}
	}
}

exit 0;
